
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>UGUI性能优化 / 憋错料</title>

    <meta name="description" content="UGUI性能优化 最近游戏性能优化排查问题时发现UGUI CanvasRenderer.OnTransformChanged每个对象会被调用函数两次,造成游戏飘伤害数字卡顿. 原因:UGUI image对象产生位移时会被触发两次. 解决方案:使用TextMeshPro虽然使用了CanvasRenderer.OnTransformChanged但是只掉用一次,Asset Store免费下载.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">UGUI性能优化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>最近游戏性能优化排查问题时发现UGUI CanvasRenderer.OnTransformChanged每个对象会被调用函数两次，造成游戏飘伤害数字卡顿。</p>
<p>原因：UGUI image对象产生位移时会被触发两次。</p>
<p>解决方案：使用TextMeshPro虽然使用了CanvasRenderer.OnTransformChanged但是只掉用一次，Asset Store免费下载。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-25 08:25:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/tor/" title="tor">tor</a>, <a href="https://www.biecuoliao.com/tag/image/" title="image">image</a>, <a href="https://www.biecuoliao.com/tag/can/" title="can">can</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%b9%e6%a1%88/" title="方案">方案</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e5%ad%97/" title="数字">数字</a>, <a href="https://www.biecuoliao.com/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%8d%e7%a7%bb/" title="位移">位移</a>, <a href="https://www.biecuoliao.com/tag/transform/" title="transform">transform</a>, <a href="https://www.biecuoliao.com/tag/erer/" title="erer">erer</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>UGUI性能优化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBE2YJ4.html" rel="bookmark">UGUI batch 规则和性能优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UGUI batch 规则和性能优化 (基础) Unity 绘图性能优化 - Draw Call Batching : http://docs.unity3d.com/Manual/DrawCallBatching.html 1.名词 1)Batch 单词 google 翻译的解释是:批量.批次. 2)Stats中的Batches参数:意思是batching后产生的批次数.(其实每一个批次就会调用一次DrawCall) 3)Unity官方文档中的batching是指batch操作和batchin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4A75Q50.html" rel="bookmark">Unity技术支持团队性能优化经验分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				https://mp.weixin.qq.com/s?__biz=MzU5MjQ1NTEwOA==&amp;mid=2247490321&amp;idx=1&amp;sn=f9f34407ee5c5d0d1edb478981299108&amp;chksm=fe1e2fbac969a6acee4eddb865d161fe09400c9147794c777ea4087e59f1e5fc3ccca5d1d0dd&amp;scene=21#wechat_redirect 在10月26日的Unity独立游戏日上,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n0l1W3d.html" rel="bookmark">iOS开发&mdash;&mdash;项目实战总结&amp;amp&semi;UITableView性能优化与卡顿问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				UITableView性能优化与卡顿问题 1.最常用的就是cell的重用, 注册重用标识符 如果不重用cell时,每当一个cell显示到屏幕上时,就会重新创建一个新的cell 如果有很多数据的时候,就会堆积很多cell.如果重用cell,为cell创建一个ID 每当需要显示cell 的时候,都会先去缓冲池中寻找可循环利用的cell,如果没有再重新创建cell 2.避免cell的重新布局 cell的布局填充等操作 比较耗时,一般创建时就布局好 如可以将cell单独放到一个自定义类,初始化时就布局好			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/gMWbr49.html" rel="bookmark">Java性能优化之JVM GC（垃圾回收机制）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java的性能优化,整理出一篇文章,供以后温故知新. JVM GC(垃圾回收机制) 在学习Java GC 之前,我们需要记住一个单词:stop-the-world .它会在任何一种GC算法中发生.stop-the-world 意味着JVM因为需要执行GC而停止了应用程序的执行.当stop-the-world 发生时,除GC所需的线程外,所有的线程都进入等待状态,直到GC任务完成.GC优化很多时候就是减少stop-the-world 的发生. JVM GC回收哪个区域内的垃圾? 需要注意的是,JV			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/E3wrzV0.html" rel="bookmark">Spark性能优化指南&mdash;&mdash;高级篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark性能优化指南--高级篇 [TOC] 前言 继基础篇讲解了每个Spark开发人员都必须熟知的开发调优与资源调优之后,本文作为&lt;Spark性能优化指南&gt;的高级篇,将深入分析数据倾斜调优与shuffle调优,以解决更加棘手的性能问题. 数据倾斜调优 调优概述 有的时候,我们可能会遇到大数据计算中一个最棘手的问题--数据倾斜,此时Spark作业的性能会比期望差很多.数据倾斜调优,就是使用各种技术方案解决不同类型的数据倾斜问题,以保证Spark作业的性能. 数据倾斜发生时的现象 绝大多数tas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/W0jyv9M.html" rel="bookmark">Mysql数据库性能优化（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				参考 http://www.jb51.net/article/82254.htm 今天,数据库的操作越来越成为整个应用的性能瓶颈了,这点对于Web应用尤其明显.关于数据库的性能,这并不只是DBA才需要担心的事,而这更是我们程序员需要去关注的事情.当我们去设计数据库表结构,对操作数据库时(尤其是查表时的SQL语句),我们都需要注意数据操作的性能.这里,我们不会讲过多的SQL语句的优化,而只是针对MySQL这一Web应用最多的数据库. mysql的性能优化无法一蹴而就,必须一步一步慢慢来,从各个方面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/BMz8d23.html" rel="bookmark">Android应用程序性能优化Tips</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				主要介绍一些小细节的优化技巧,虽然这些小技巧不能较大幅度的提升应用性能,但是恰当的运用这些小技巧并发生累积效应的时候,对于整个App的性能提升还是有不小作用的.通常来说,选择合适的算法与数据结构会是你首要考虑的因素,在这篇文章中不会涉及这方面的知识点.你应该使用这篇文章中的小技巧作为平时写代码的习惯,这样能够提升代码的效率. 通常来说,高效的代码需要满足下面两个原则: 不要做冗余的工作 尽量避免执行过多的内存分配操作 To ensure your app performs well across			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4NA9V3.html" rel="bookmark">使用Html5&plus;C&num;&plus;微信 开发移动端游戏详细教程&colon;（六）游戏界面布局与性能优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇教程我们主要讲解在游戏界面上的布局一般遵循哪些原则和一些性能优化的通用方法. 接着教程(五),我们通过Loading类一次性加载了全部图像素材,现在要把我们所用到的素材变成图片对象显示在界面上,由上而下,首先是top层,top里面包涵了玩家(微信)头像,关卡信息,怪物血条信息,玩家金币,玩家宝石,玩家总攻击力. 定义函数 setTop 来初始化top层: function setTop() { TopDiv = new LSprite();//定义top层 var Topshape = ne			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/pMP8OzM.html" rel="bookmark">电商邮件服务平台性能优化谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从今年一月份开始,团队陆续完成了邮件服务的架构升级.新平台上线运行的过程中也发生了一系列的性能问题,即使很多看起来微不足道的点也会让整个系统运行得不是那么平稳,今天就将这段时间的问题以及解决方案统一整理下,希望能起到抛砖的作用,让读者在遇到类似问题的时候能多一个解决方案. 新平台上线后第一版架构如下: 这版架构上线后,我们遇到的第一个问题:数据库读写压力过大后影响整体服务稳定. 表现为: 1.数据库主库压力高,同时伴有大量的读,写操作. 2.远程服务接口性能不稳定,业务繁忙时数据库的插入操作延迟			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xQrLL3.html" rel="bookmark" class="title">Headfirst设计模式的C&plus;&plus;实现&mdash;&mdash;观察者模式&lpar;Observer&rpar;</a>
					<div>
						WeatherData.h 1 #ifndef WEATHERDATA_H_INCLUDED 2 #define WEATHERDATA_H_INCLUDED 3 4 #include &lt;set ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzaBkA4.html" rel="bookmark" class="title">简单的Web留言本</a>
					<div>
						1 &lt;!DOCTYPE html&gt; 2 &lt;html&gt; 3 &lt;head lang=&quot;en&quot;&gt; 4 &lt;meta charset=&quot;U ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vEWdL0.html" rel="bookmark" class="title">unity内部：内存 和 性能（以及Unity5的升级优化）</a>
					<div>
						      我们的脚本代码里经常会需要访问gameObject引用或者某个组件的引用,最好的方式当然是在脚本Awake的时候就把这些可能访问的东西都缓存下来:如果需要访问临时gameObject实例的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wv9G10.html" rel="bookmark" class="title">win10无法新建文件夹怎么办 win10右键新建菜单设置方法</a>
					<div>
						有朋友安装了win10系统后发现右键菜单中没有新建项,而平时使用新建 - 文件夹项的机率很高.如何才能恢复桌面右键菜单中的新建项呢? 右键点击桌面空白处,在右键菜单中发现没有新建项: 桌面右键菜单没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5D2A4.html" rel="bookmark" class="title">路由器WDS桥接教程</a>
					<div>
						因为有吧友买了此款路由又不会桥接,因此做这个教程.老鸟自动路过,废话不多说,下面开始讲解. 1.wifi密码破解和路由器用户名和密码部分请自行解决,我只讲桥接部分.首先,在浏览器里输入192.168. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYop14.html" rel="bookmark" class="title">React为啥很多类里的标签上事件处理函数要用bind&lpar;this&rpar;</a>
					<div>
						render() { return ( &lt;div&gt; &lt;p onClick={this.clickHandler.bind(this)}&gt;vz&lt;/p&gt; &lt;/di ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8p2Q3.html" rel="bookmark" class="title">实验11：Problem B&colon; 分数类的类型转换</a>
					<div>
						Home Web Board ProblemSet Standing Status Statistics Problem B: 分数类的类型转换 Problem B: 分数类的类型转换 Time Li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvyXD0.html" rel="bookmark" class="title">《C与指针》第一章练习</a>
					<div>
						本章例程 程序1.1 重排字符 1 #include &lt;stdio.h&gt; 2 #include &lt;stdlib.h&gt; 3 #include &lt;string.h&gt; 4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmY1KnM.html" rel="bookmark" class="title">java 虚拟机学习--未完</a>
					<div>
						1.学习了解GC垃圾回收 参考:https://www.ibm.com/developerworks/cn/java/l-JavaMemoryLeak2/ 2.类加载机制 http://blog.cs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgE78n3.html" rel="bookmark" class="title">spring学习毕竟</a>
					<div>
						java web 24 堂课  spring学习笔记 16.01 构造器注入 1.\applicationContext.xml 默认在src目录下 &lt;bean name=&quot;user& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AEBYz4.html" rel="bookmark" class="title">各种引用方式提高string的操作效率</a>
					<div>
						众所周知string的真身是具备值类型操作性质的引用类型,在本文中我们不去探讨它的区别,为了方便描述,统一把string作为值类型来理解. 例子都基于: class Data { public int ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEBPJ0.html" rel="bookmark" class="title">游戏编程系列&lbrack;1&rsqb;--游戏编程中RPC协议的使用</a>
					<div>
						RPC(Remote Procedure Call Protocol)--远程过程调用协议,它是一种通过网络从远程计算机程序上请求服务,而不需要了解底层网络技术的协议.RPC协议假定某些传输协议的存在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vBZag3.html" rel="bookmark" class="title">html5本地存储（localStorage）使用介绍</a>
					<div>
						1.html5几种存储形式 本地存储(localStorage &amp;&amp; sessionStorage) 离线缓存(application cache) indexedDB 和 webSQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAdNG3.html" rel="bookmark" class="title">Verify Preorder&sol;Inorder&sol;Postorder Sequence in Binary Search Tree</a>
					<div>
						Verify Preorder Sequence in Binary Search Tree \Given an array of numbers, verify whether it is the  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pN6NK0.html" rel="bookmark" class="title">centos 6&period;5安装vncserver 并开启远程桌面</a>
					<div>
						vnc是一款使用广泛的服务器管理软件,可以实现图形化管理,下面简单介绍一下如何在centos6.5下安装vnc. 1.下载vncserver yum install tigervnc tigervnc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0azvWJ3.html" rel="bookmark" class="title">scroll bar与document 宽度与js的关系</a>
					<div>
						一个重要的细节 首先从浏览器模式来说 如果document有responsive meta,在普通模式下 scroll bar是附加在文档的最左边 而在device mode下 scroll bar  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzln64.html" rel="bookmark" class="title">&lpar;二&rpar; 登陆身份验证后注销</a>
					<div>
						//前端脚本function LoginOut() { if (window.confirm(&quot;是否退出?&quot;)) { window.location.href = &quot;/A ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyPeoM.html" rel="bookmark" class="title">OC小实例关于init方法不小心的错误</a>
					<div>
						*:first-child { margin-top: 0 !important; } body &gt; *:last-child { margin-bottom: 0 !important; }  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MooZBbM.html" rel="bookmark" class="title">阿里技术总监郭东白：创新之歌该如何唱</a>
					<div>
						今年7月份, 我参加了一个集团组织的名字叫&quot;创意过山车&quot;的培训.这个三天半的培训集中在一个问题上, 就是&quot;创新之歌该如何唱&quot;. 这个会之后,我们又有几个月的时间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qO7gNM.html" rel="bookmark" class="title">QML中的ExclusiveGroup</a>
					<div>
						Exclusive这个单词在高中应该都学过,是互斥的意思.如果你没有上过或者还没有上到高中,那你非常棒,计算机领域的大师很多都是这么起步的. ExclusiveGroup顾名思义就是互斥分组,效果很明 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
